//Author : pakhandi
//
using namespace std;

#include <bits/stdc++.h>

#define wl(n) while(n--)
#define fl(i,a,b) for(i=a; i<b; i++)
#define rev(i,a,b) for(i=a; i>=b; i--)

#define si(n) scanf("%d", &n)
#define sll(l) scanf("%lld",&l)
#define ss(s) scanf("%s", s)
#define sc(c) scanf("%c", &c)
#define sd(f) scanf("%lf", &f)

#define pi(n) printf("%d\n", n)
#define pll(l) printf("%lld\n", l)
#define ps(s) printf("%s\n", s)
#define pc(c) printf("%c\n", c)
#define pd(f) printf("%lf\n", f)

#define debug(x) cout<<"\n#("<<x<<")#\n"
#define nline printf("\n")

#define mem(a,i) memset(a,i,sizeof(a))

#define MOD 1000000007
#define ll long long
#define u64 unsigned long long

#define PB push_back
#define SZ size
#define MP make_pair

int tot, metPerDay, days, target;

ll C[26][26];
long double dp[51][31];

long double rec(int day, int happyPokemons)
{
	if(day == days)
	{
		if(happyPokemons == target)
			return 1.0;
		return 0.0;
	}
	
	long double &ret = dp[day][happyPokemons];
	if(ret >= 0.000000000)
		return ret;
	ret = 0.00000000;

	int i;
	fl(i,0,metPerDay+1)
	{
		int newFriends = i;
		int oldFriends = metPerDay - newFriends;
		
		if(newFriends > tot-happyPokemons || oldFriends > happyPokemons)    continue;

		ret += ( 	C[happyPokemons][oldFriends] 
					* C[tot-happyPokemons][newFriends] 
					* rec(day+1,happyPokemons+newFriends) 
				) / ( 1.0 * C[tot][metPerDay] );
	}

	return ret;
}

void preprocess()
{
	int i, j;
	C[0][0] = 1;
	fl(i,1,26)
	{
		C[i][0] = 1;
		fl(j,1,i+1)
			C[i][j] = C[i-1][j] + C[i-1][j-1];
	}
}


int main()
{
	int i, j;

	preprocess();

	int cases;

	si(cases);

	assert(cases <= 100);

	wl(cases)
	{
		si(tot);	si(metPerDay);	si(days); si(target);

		assert(tot >= 1 && tot <= 25);
		assert(metPerDay >= 1 && metPerDay <= tot);
		assert(days >= 1 && days <= 50);
		assert(target >= 0 && target <= tot);

		fl(i,0,51)
			fl(j,0,31)
				dp[i][j] = -1.0;
		printf("%0.6Lf\n", rec(0,0));
	}


	return 0;
}
/*
	Powered by Buggy Plugin
*/
